Components.utils.import("resource://modules/kclobserver.jsm");
Components.utils.import("resource://gre/modules/ctypes.jsm");

function debugprint(str){
    var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
	getService(Components.interfaces.nsIConsoleService);
    aConsoleService.logStringMessage(str);
}

var KclInsp = {

    init: function(){
        KclHttpObserver.init();
        KclHttpObserver.addCallback( KclInspCallback );
    },

    destroy: function(){
        KclHttpObserver.removeCallback( KclInspCallback );
        KclHttpObserver.destroy();
    }

}



const Cc = Components.classes;
const Ci = Components.interfaces;

const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
const HTML_NS= "http://www.w3.org/1999/xhtml";

function KclInspCallback(request,str){
    var url = request.name;

    str = str.substring( str.indexOf('svdata=')+7 );
    var data = JSON.parse(str);

    if( url.match(/kcsapi\/api_get_master\/ship/) ){
        KclInfo.gMasterShip = data.api_data;
        KclInfo.gMasterShipStr = str;
        debugprint('loading master.ship');
    }else if( url.match(/kcsapi\/api_get_member\/ship2/) ){
        KclInfo.gMemberShip = data.api_data;
        KclInfo.gMemberShipStr = str;
        debugprint('loading member.ship2.api_data ok.');

        KclInfo.gMemberFleet = data.api_data_deck;
        debugprint('loading member.ship2.api_data_deck ok.');

        for( let i in KclInfo.gMemberFleet ){
            icnt = parseInt(i);
            debugprint('parse fleet'+icnt);
            debugprint('parse fleet/'+KclInfo.gMemberFleet[icnt].api_name);
            for( let j in KclInfo.gMemberFleet[icnt].api_ship){
                jcnt = parseInt(j);
                debugprint('parse fleet_ship'+jcnt);
                let mShip = KclInfo.gMemberFleet[icnt].api_ship[jcnt];
                debugprint("fleet"+(icnt+1)+"ship"+(jcnt+1)+"name/"+mShip);
                if(mShip > 0){
                    let memShip = SearchMemberShip(mShip);
                    let msShip = SearchMasterShip(mShip);
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"cond").value = memShip.api_cond;
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"name").value = msShip.api_name;

                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup1").value = "[" + memShip.api_kyouka[0] + "/" + (parseInt(msShip.api_houg[1]) - parseInt(msShip.api_houg[0])) + "]"

                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup2").value = "[" + memShip.api_kyouka[1] + "/" + (parseInt(msShip.api_raig[1]) - parseInt(msShip.api_raig[0])) + "]"

                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup3").value = "[" + memShip.api_kyouka[2] + "/" + (parseInt(msShip.api_tyku[1]) - parseInt(msShip.api_tyku[0])) + "]"

                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup4").value = "[" + memShip.api_kyouka[3] + "/" + (parseInt(msShip.api_souk[1]) - parseInt(msShip.api_souk[0])) + "]"

                }else{
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"cond").value = ""
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"name").value = ""
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup1").value = ""
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup2").value = ""
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup3").value = ""
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup4").value = ""
                }
            }
        }

        
    }else if( url.match(/kcsapi\/api_get_member\/questlist/) ){
        KclInfo.gQuestList = data.api_data.api_list;
        debugprint('loading questlist');
        debugprint(typeof KclInfo.gQuestList);
        for( let i in KclInfo.gQuestList ){
            icnt = parseInt(i);
            debugprint('result/' + (typeof KclInfo.gQuestList[icnt]));
            if ((KclInfo.gQuestList[icnt] instanceof Object)){
                debugprint('isarray');
                document.getElementById("quest"+(icnt+1)+"name").value = KclInfo.gQuestList[icnt].api_title;
                if(KclInfo.gQuestList[icnt].api_now_count instanceof Array){
                    document.getElementById("quest"+(icnt+1)+"score").value = "[" + KclInfo.gQuestList[icnt].api_now_count.join() + "]";
                    document.getElementById("quest"+(icnt+1)+"require").value = "[" + KclInfo.gQuestList[icnt].api_clear_count.join() + "]";
                }else{
                    document.getElementById("quest"+(icnt+1)+"score").value = "[" + KclInfo.gQuestList[icnt].api_now_count + "]";
                    document.getElementById("quest"+(icnt+1)+"require").value = "[" + KclInfo.gQuestList[icnt].api_clear_count + "]";

                }
            }else{
                document.getElementById("quest"+(icnt+1)+"name").value = "";
                document.getElementById("quest"+(icnt+1)+"score").value = "";
                document.getElementById("quest"+(icnt+1)+"require").value = "";
            }
        }
    }
}

function SearchMemberShip( member_ship_id ){
    let sortno;
    try{
        for( let cnt in KclInfo.gMemberShip ){
            let ship = KclInfo.gMemberShip[cnt];
            let id = ship.api_id;
            sortno = ship.api_sortno;
            if( id==member_ship_id ){
                return ship;
            }
        }
    } catch (err) {
    }
    return "";
}

function SearchMasterShip( member_ship_id ){
    let sortno;
    try{
        for( let cnt in KclInfo.gMemberShip ){
            let ship = KclInfo.gMemberShip[cnt];
            let id = ship.api_id;
            sortno = ship.api_sortno;
            if( id==member_ship_id ) break;
        }
        debugprint(member_ship_id+"/"+sortno);
        for( let cnt in KclInfo.gMasterShip ){
            let ship = KclInfo.gMasterShip[cnt];
            if( ship.api_sortno==sortno ){
                return ship;
            }
        }
    } catch (err) {
    }
    return "";
}

function CopyToClipboard(str){
    if(str.length<=0) return;
    let gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].  
	getService(Components.interfaces.nsIClipboardHelper);  
    gClipboardHelper.copyString(str);
}

window.addEventListener("load", function(e){ KclInsp.init(); }, false);
window.addEventListener("unload", function(e){ KclInsp.destroy(); }, false);